<?php

namespace app\common\model;

use think\Model;


class PreOrder extends Model
{

    

    

    // 表名
    protected $name = 'pre_order';
    
    // 自动写入时间戳字段
    protected $autoWriteTimestamp = 'integer';

    // 定义时间戳字段名
    protected $createTime = 'createtime';
    protected $updateTime = 'updatetime';
    protected $deleteTime = false;

    // 追加属性
    protected $append = [
        'pre_time_text',
        'order_time_text',
        'cancel_time_text',
        'pre_order_status_text'
    ];
    

    
    public function getPreOrderStatusList()
    {
        return ['0' => '已取消', '1' => '待处理', '2' => '已开单'];
    }


    public function getPreTimeTextAttr($value, $data)
    {
        $value = $value ? $value : (isset($data['pre_time']) ? $data['pre_time'] : '');
        return is_numeric($value) ? date("Y-m-d H:i:s", $value) : $value;
    }


    public function getOrderTimeTextAttr($value, $data)
    {
        $value = $value ? $value : (isset($data['order_time']) ? $data['order_time'] : '');
        return is_numeric($value) ? date("Y-m-d H:i:s", $value) : $value;
    }


    public function getCancelTimeTextAttr($value, $data)
    {
        $value = $value ? $value : (isset($data['cancel_time']) ? $data['cancel_time'] : '');
        return is_numeric($value) ? date("Y-m-d H:i:s", $value) : $value;
    }


    public function getPreOrderStatusTextAttr($value, $data)
    {
        $value = $value ? $value : (isset($data['pre_order_status']) ? $data['pre_order_status'] : '');
        $list = $this->getPreOrderStatusList();
        return isset($list[$value]) ? $list[$value] : '';
    }

    protected function setPreTimeAttr($value)
    {
        return $value === '' ? null : ($value && !is_numeric($value) ? strtotime($value) : $value);
    }

    protected function setOrderTimeAttr($value)
    {
        return $value === '' ? null : ($value && !is_numeric($value) ? strtotime($value) : $value);
    }

    protected function setCancelTimeAttr($value)
    {
        return $value === '' ? null : ($value && !is_numeric($value) ? strtotime($value) : $value);
    }

    public function user()
    {
        return $this->hasOne('User', 'id', 'user_id',[],'LEFT');
    }
}
